% FSSP3alg10_2_sub.m
%
%  This function subprogram detects a positive DC level signal
%  embedded in IID Laplacian noise with known variance.  It computes 
%  the detection statistic and the threshold.
%
%  Input parameters:
%    A  - DC level signal height
%    x  - real array of dimension Nx1 containing data
%    sig2 - variance of Laplacian noise
%    Pfa  - probability of false alarm desired
%
%  Output parameters:
%    T   - detection statistic
%    gamma - threshold required
%
%  External function subprograms required:
%    Qinv.m   
%     
function [T,gamma]=FSSP3alg10_2_sub(A,x,sig2,Pfa)
N=length(x);
gx=sqrt(2/sig2)*sign(x); % compute output of limiter
T=sum(gx*A); % compute detection statistic - see (10.9)
E=N*A^2;  % compute signal energy
gamma=sqrt((2/sig2)*E)*Qinv(Pfa);  % calculation of thrshold - see (10.9)


    


 
 
 
 
 
         
   
   
   
   
   
   
   
