% FSSP3alg10_3_sub.m
%
%  This function subprogram detects a known signal
%  embedded in correlated with known covariance matrix.  It computes the 
%  detection statistic and the threshold.
%
%  Input parameters:
%    s  - real array of dimension N x 1 containing signal samples
%    x  - real array of dimension N x 1 containing data
%    C  - real array of dimension N x N containing covariances 
%    Pfa  - probability of false alarm desired
%
%  Output parameters:
%    T   - detection statistic
%    gamma - threshold required
%
%  External function subprograms required:
%    Qinv.m   
%     
function [T,gamma]=FSSP3alg10_3_sub(s,x,C,Pfa)
T=x'*inv(C)*s;
gamma=sqrt(s'*inv(C)*s)*Qinv(Pfa);

    

 

 
 
 
 
 
         
   
   
   
   
   
   
   
