%  FSSP3alg10_4_sub.m
%
%  This function subprogram detects a stationary random Gaussian signal
%  with known autocorrelation matrix embedded in WGN.  It computes the 
%  estimator-correlator detection statistic.
%
%  Input parameters:
%    x  - real array of dimension Nx1 containing data
%    rs  - real array of dimension Nx1 containing the signal autocorrelation
%           samples arranged as [rs[0] rs[1]... rs[N-1]]^T
%
%  Output parameters:
%    T   - detection statistic
%
function T=FSSP3alg10_4_sub(x,rs,sig2)
N=length(x);
for i=1:N
    for j=1:N
        Rs(i,j)=rs(abs(i-j)+1);  % compute autocorrelation matrix
    end
end
shat=Rs*inv(Rs+sig2*eye(N))*x;  % compute MMSE estimate (matrix Wiener 
                                % smoother) of signal
T=x'*shat;  % compute detection statistic - see (10.12)


        

   
