% FSSP3alg10_5_sub.m
%
%  This function subprogram detects an unknown signal 
%  embedded in WGN with known variance by using an energy detector.  
%  It computes the detection statistic and the threshold.
%
%  Input parameters:
%    x  - real array of dimension Nx1 containing data
%    sig2 - variance of WGN
%    Pfa  - probability of false alarm desired
%
%  Output parameters:
%    T   - detection statistic
%    gamma - threshold required
%
%  External function subprograms required:  ED_threshold.m
%          
function [T,gamma]=FSSP3alg10_5_sub(x,sig2,Pfa)
N=length(x);
T=x'*x;  % compute detection statistic - see (10.13)
xmax=N+10*sqrt(2*N);  % this upper limit for the threshold is the mean plus
                      % 10 standard deviations
gamma=ED_threshold(N,Pfa,sig2,xmax);  % calculate threshold - see (10.13)
    

 

 
 
 
 
 
         
   
   
   
   
   
   
   
