% FSSP3alg10_6_sub.m
%
%  This function subprogram detects a signal known except for amplitude
%  embedded in WGN with known variance.  It computes the detection 
%  statistic and the threshold.
%
%  Input parameters:
%    s  - real array of dimension N x 1 containing signal samples
%    x  - real array of dimension N x 1 containing data
%    sig2 - variance of WGN
%    Pfa  - probability of false alarm desired
%
%  Output parameters:
%    T   - detection statistic
%    gamma - threshold required
%
%  External function subprograms required:
%    Qinv.m   
%     
function [T,gamma]=FSSP3alg10_6_sub(s,x,sig2,Pfa)
T=((x'*s)^2)/(sig2*(s'*s));  % compute detection statistic - see (10.14)
gamma=(Qinv(Pfa/2))^2;  % compute threshold - see (10.14)

    

 

 
 
 
 
 
         
   
   
   
   
   
   
   
