% FSSP3alg10_7_sub.m
%
%  This function subprogram detects a sinusoidal signal known except 
%  for amplitude and phase embedded in WGN with known variance.  It 
%  computes the detection statistic and the threshold.
%
%  Input parameters:
%    f0 - frequency of sinusoid
%    x  - real array of dimension N x 1 containing data
%    sig2 - variance of WGN
%    Pfa  - probability of false alarm desired
%
%  Output parameters:
%    T   - detection statistic
%    gamma - threshold required
%  
function [T,gamma]=FSSP3alg10_7_sub(f0,x,sig2,Pfa)
N=length(x);
n=[0:N-1]';
e=exp(-j*2*pi*f0*n);
T=(1/N)*abs(x'*e)^2;
gamma=sig2*log(1/Pfa);

    

 

 
 
 
 
 
         
   
   
   
   
   
   
   
