% FSSP3alg10_9_sub.m
%
%  This function subprogram detects a known signal with unknown arrival
%  time embedded in WGN with known variance.  It computes the detection 
%  statistic and also gives the arrival time when a signal is detected. 
%
%  Input parameters:
%    s  - real array of dimension M x 1 (M<<N) containing the known signal
%    x  - real array of dimension N x 1 containing data
%
%  Output parameters:
%    T   - detection statistic
%    n0hat - estimate of arrival time
%   
function [T,n0hat]=FSSP3alg10_9_sub(s,x)
M=length(s);
N=length(x);
for n0=1:N-M+1  % set possible values of arrival times so that signal 
                % is contained within the time interval [0,N-1]
    T1(n0,1)=x(n0:n0+M-1,1)'*s;  % compute detection statistic - see (10.18)
end
[T n0hat]=max(T1);  % find maximum over all arrival times and 
                    % estimate of arrival time
    

  
 
 
 
 
         
   
   
   
   
   
   
   
