%  FSSP3alg9_12_sub.m
%
%  This program estimates the outcome of a random signal embedded in white
%  noise using a Wiener smoother implemented in matrix form.
%
%  Input parameters:
%    x  - real array of dimension N x 1 containing the data samples
%    rs  - real array of dimension N x 1 containing the signal 
%          autocorrelation lags arranged as [rs[0] rs[1] ... rs[N-1]]^T
%    sig2  - white noise variance
%
%  Output parameters:
%    shat - estimate of the signal
%
function shat=FSSP3alg9_12_sub(x,rs,sig2)
N=length(x);
for i=1:N
    for j=1:N
        Rs(i,j)=rs(abs(i-j)+1); % construct N x N signal autocorrelation 
                                % matrix - see (9.22)
    end
end
shat=Rs*inv(Rs+sig2*eye(N))*x; % compute MMSE estimate of s[n] - see (9.21)

        

   
