% FSSP3alg9_13_sub.m
%
%  This program estimates the outcome of a random signal embedded in 
%  interference and white noise using an adaptive noise canceler.  The
%  canceler begins at n=p-1 to allow the FIR filter to have nonzero 
%  initial conditions.
%
%  Input parameters:
%    x   - real array of dimension N x 1 containing the data samples
%    xR  - real array of dimension N x 1 containing the reference 
%          interference samples
%    p   - number of FIR filter coefficients
%
%  Output parameters:
%    shat - estimate of the signal
%    hhat - estimated FIR filter coefficients
%
function [shat,hhat]=FSSP3alg9_13_sub(x,xR,p)
N=length(x);
for i=1:N-p+1
 for j=1:p
    H(i,j)=xR(i-j+p); % set up H matrix
end
end
bfx=x(p:N,1);  % set up x vector
hhat=inv(H'*H)*H'*bfx; % estimate the FIR filter coefficients
shat=[x(1:p-1);bfx-H*hhat]; % subtract out estimated interference given by
% H*hat for the data samples x[n], n=p-1,p,...,N-1






        

   
