% FSSP3alg9_2_sub.m
%
%  This function subprogram estimates the amplitude and phase of a 
%  sinusoid with known frequency embedded in WGN, using the MLD.   It is 
%  assumed that the sinusoid is of the form A*cos(2*pi*f0*n+phi) 
%  for n=0,1,...,N-1.
%
%  Input parameters:
%    x  - real array of dimension Nx1 containing data
%    f0 - sinusoidal frequency
%
%  Output parameters:
%    Ahat  - estimate of amplitude
%    phihat - estimate of phase in radians
%
function [Ahat,phihat]=FSSP3alg9_2_sub(x,f0)
N=length(x);
n=[0:N-1]';
arg=2*pi*f0*n;
H=[cos(arg) sin(arg)]; % construct H matrix
alphahat=inv(H'*H)*H'*x;  % see (9.3)
Ahat=sqrt(alphahat(1)^2+alphahat(2)^2);  % see (9.2)
phihat=atan2(-alphahat(2),alphahat(1));  % see (9.2)



 
 

 

 
 
 
 
 
         
   
   
   
   
   
   
   
