% FSSP3alg9_4_sub.m
%
%  This function subprogram estimates the delay time of a known signal
%  in WGN using the MLE of (9.7).  It is assumed that
%  the signal is of the form s[n] for n=0,1,...,M-1, the data record is
%  N samples in length and 0<=n0<=N-M
%
%  Input parameters:
%    x  - real array of dimension Nx1 containing data
%
%  Output parameters:
%    n0hat  - estimate of delay time
%    J      - the running correlator output
%     
function [n0hat J]=FSSP3alg9_4_sub(x,s,J)
N=length(x);
M=length(s);
for n0=0:N-M  % see (9.7)
    xdat=x(n0+1:n0+M,1); % pick out data for assumed signal interval
    J(n0+1,1)=xdat'*s;  % correlate data with delayed signal
end
[maxJ I]=max(J);  % find maximum and location of maximum of objective function
n0hat=I-1;  % convert to estimate of time delay



 
 

 

 
 
 
 
 
         
   
   
   
   
   
   
   
