% FSSP3alg9_7_sub.m
%
%  This function subprogram estimates the power of a random signal whose
%  power spectral density is known up to a scale factor.
%
%  Input parameters:
%    s  - real array of dimension Nx1 containing data
%    freq - frequencies of scaled PSD, denoted by Q(f)
%    Q    - scaled PSD values corresponding to frequencies in freq array
%
%  Output parameters:
%    P0hat  - estimate of total power
%
function P0hat=FSSP3alg9_7_sub(s,freq,Q)
N=length(s);
n=[0:N-1]';  % set up time samples
L=length(freq);  % number of frequency samples of Q(f)
for i=1:L
    e=exp(j*2*pi*freq(i)*n);
    I(i,1)=(1/N)*(abs(e'*s))^2;  % compute samples of periodogram to 
                                 % approximate integral of (9.14)
end
P0hat=sum(I./Q)/L;  % estimate of P0 - see (9.14)











 
 
 
 
 
         
   
   
   
   
   
   
   
