% FSSP3exer10_2.m
%
% This program compares the use of a limiter on nonGaussian noise,
% specifically IID noise with a Gaussian mixture PDF. The number of high
% level events of the detection statistic is reduced due to the limiter.
% The data consists of noise only.
%
clear all
close all
randn('state',0) % initialize Gaussian random number generator
N=50;
ntrials=10000;  % number of trials
epsilon=0.01; % set up parameters for Gaussian mixture noise - see (4.19)
sig21=0.5;sig22=50;
for m=1:ntrials
w=Gaussmix_gendata(sig21,sig22,epsilon,N); % generate noise samples
T_sum(m,1)=sum(w)/sqrt( N*(sig21*(1-epsilon)+sig22*epsilon) ); % compute 
                                          % detection statistics
T_sgn(m,1)=sum(sign(w))/sqrt(N);
end
mm=[1:ntrials]';
figure
stem(mm,T_sum)
grid
axis([1 ntrials -5 5])
title('sum detector')
figure
stem(mm,T_sgn)
grid
axis([1 ntrials -5 5])
title('sign detector')













 
 

 

 
 
 
 
 
         
   
   
   
   
   
   
   
