% FSSP3exer10_4.m
%
%  This program determines the threshold for an estimator-correlator 
%  detector using a Monte Carlo computer evaluation.  
%
close all
clear all
randn('state',0);  % initialize Gaussian random number generator
a1=-0.9; % set up parameters for signal covariance matrix C_s
sig2u=1;
sig2=5;  % WGN variance
N=100;
n=[0:N-1]';
r0=sig2u/(1-a1^2); % calculate autocorrelation sequence for lag k=0
rs=r0*(-a1).^[0:N-1]';  % calculate remaining autocorrelation sequence values
                       % for k=1,2,...,N-1 needed for signal covariance
                       % matrix - see (9.24)

for m=1:1000  % use 1000 trials 
w=sqrt(sig2)*randn(N,1); % generate WGN sample
T0(m,1)=FSSP3alg10_4_sub(w,rs,sig2); % calculate detection statistic - see (10.12)
end
T0_sort=sort(T0);  % sort detection statistics from minimum to maximum
gamma=T0_sort(991) % find threshold by determining value for which
                   % only 1% of the detection statistics exceed this value





   


        

   
