% FSSP3exer10_7.m
%
% This program computes the detection statistic (the periodogram evaluated
% at f0) for a sinusoid (see (10.16)).  The value is approximately N/4.
%
clear all
close all
f0=0.1; % set up signal parameter
sig2=1; % set variance of WGN, not used here
Pfa=0.01; % set Pfa, not used here
for N=10:100 % compute detection statistic for varying data record lengths
n=[0:N-1]'; % set up time samples
s=cos(2*pi*f0*n); % compute signal samples
[T(N,1),gamma]=FSSP3alg10_7_sub(f0,s,sig2,Pfa); % call subprogram to find
                                                % detection statistic 
                                                % - see (10.16)
end
figure
plot([10:100]',T(10:100))  % plot detection statistic (for the signal only)
                           % versus data record length N
grid
xlabel('N')
ylabel('periodogram value at f0')







 
 

 

 
 
 
 
 
         
   
   
   
   
   
   
   
