% FSSP3exer10_8.m
%
% This program compares the number of false alarms of the periodogram
% detection statistic when it is computed for a single known frequency
% versus when the frequency is unknown and we must search over all possible
% frequencies.
%
clear all
close all
randn('state',0) % initialize Gaussian random number generator
N=20;
n=[0:N-1]'; % set up time samples
A=1; % set up signal parameters
phi=pi/2; 
f0=0.1;
s=A*cos(2*pi*f0*n+phi); % compute sinusoidal signal
sig2=1;  % set WGN variance
Pfa=0.01; % set Pfa
ntrials=10000;
Nfft=N;  % search for the unknown frequency over N/2-1 frequencies, 
         % corresponding to 0<f0<1/2.  A denser grid of frequencies will
         % increase the number of false alarms slightly since there will
         % be more possibilities for threshold crossings but also the 
         % Fourier transform values become more heavily correlated.
for m=1:ntrials
w=sqrt(sig2)*randn(N,1);  % generate WGN
[T_known(m,1),gamma_known]=FSSP3alg10_7_sub(f0,w,sig2,Pfa);
[T_unknown(m,1),gamma_unknown]=FSSP3alg10_8_sub(w,sig2,Pfa,Nfft);
end
count_known=0;  % count up the number of threshold crossings for each 
                % detection statistic
count_unknown=0;
for m=1:ntrials
    if T_known(m)>gamma_known
        count_known=count_known+1;
    end
        if T_unknown(m)>gamma_known
        count_unknown=count_unknown+1;
        end
end
    
count_known
count_unknown
    
    






 
 

 

 
 
 
 
 
         
   
   
   
   
   
   
   
