%  FSSP3exer11_1.m
%
% This program computes the sample mean of the averaged PSD estimate for
% comparison to Figure 11.2a.  A Hamming data window is used to smooth 
% out the ripples (reduce the leakage).
%
% External function subprograms required: 
% ARgendata.m, PSD_est_avper_exer11_1.m, ARpsd.m
%
clear all
close all
randn('state',0) %initialize Gaussian random number generator
N=500;
L=20; % length of data for each block
a=[0 0.9025]'; % AR filter parameters
sig2u=1; % AR excitation noise variance
for i=1:30 % generate N points of data for each outcome
x=ARgendata(a,sig2u,N);
%
% In the PSD_est_avper subprogram replace 
% Pper=(1/L)*abs(fftshift(fft(y,1024))) .^2; by
% Pper=(1/(hamming(L)'*hamming(L)))*abs(fftshift(fft(y.*hamming(L),Nfft))) .^2;
%
[freq,Pavper(:,i)]=PSD_est_avper_exer11_1(x,L,1024,0,0);
end
Pm=mean(Pavper'); % find mean of the outcomes
Pavper_mean=Pm';  % convert to column vector for plotting
[powsd_true,freq]=ARpsd(a,sig2u,1024); % compute the true PSD
plot(freq,10*log10(Pavper_mean),freq,10*log10(powsd_true)) 
grid
xlabel('f')
ylabel('Mean PSD estimate and true PSD')
legend('Mean of averaged periodogram estimate (with data windowing)', 'True PSD')


