% FSSP3exer11_2.m
%
%  This program examines the "window closing" approach to choosing the
%  value of the block length L for the averaged periodogram spectral 
%  estimator.
%
% External function subprograms required: 
% ARpsd.m, ARgendata.m, PSD_est_avper.m
%
clear all
close all
randn('state',0) %initialize Gaussian random number generator
N=500;
a=[0 0.9025]'; % set AR filter parameters
sig2u=1; % set AR excitation noise variance
[powsd_true,freq]=ARpsd(a,sig2u,1024); % compute the true PSD
x=ARgendata(a,sig2u,N); % generate N samples of data
L=[10 20 50 100]';  % set up increasing block lengths
for i=1:4
[freq,Pavper]=PSD_est_avper(x,L(i),1024,0,0);  % call subprogram to compute
                                  % averaged periodogram spectral estimator
plot(freq,10*log10(Pavper),freq,10*log10(powsd_true)) 
grid
xlabel('f')
ylabel('PSD (dB)')
legend('Averaged periodogram', 'True PSD')
pause
close all
end




