% FSSP3exer11_4.m
%
% This program illustrates the better resolution of the AR spectral
% estimator for high SNR but the deteriorating performance at lower SNR.
%
% External function subprograms required: 
%  PSD_est_AR_cov.m
%
clear all
close all
randn('state',0) % initialize random number generator
n=[0:15]'; % set up time samples
x=cos(2*pi*0.11*n)+0.5*cos(2*pi*0.13*n); % generate two closely spaced in
                                         % frequency sinusoids
figure
PSD_est_AR_cov(x,4,1,1024,1); % use the covariance method to estimate
                              % AR parameters with p=4

x=cos(2*pi*0.1*n)+0.5*cos(2*pi*0.13*n)+0.01*randn(16,1); % generate two 
% closely spaced in frequency sinusoids but now add WGN
figure
PSD_est_AR_cov(x,4,1,1024,1); % use the covariance method to estimate
                              % AR parameters with p=4
        






