% FSSP3exer11_5.m
%
%  This program illustrates that too high an AR model order can produce
%  "spurious peaks", i.e., resonances that are not in the PSD but are due
%  to statistical fluctuation exhibited by the particular outcome of the 
%  random process.  The program pauses between different values of p.
%
% External function subprograms required: 
% ARgendata.m, PSD_est_AR_Burg.m
%
clear all
close all
randn('state',0) %initialize Gaussian random number generator
N=30;
a=[0 0.9025]'; % AR filter parameters
sig2u=1; % AR excitation noise variance
x=ARgendata(a,sig2u,N); % generate AR process data
p=[2 6 10]'; % try these model orders
for i=1:3
[freq,PARdB_Burg]=PSD_est_AR_Burg(x,p(i),1,1024,1);  % estimate PSD and plot
                                                     % in dB
axis([-0.5 0.5 -10 30])  % set vertical axis to match that in Figure 11.9
pause
close all
end




