% FSSP3exer12_11.m
%
%  This program determines the magnitude of the complex amplitude for the 
% detection of a complex sinusoid in CWGN necessary to attain a given Pd.
%
%  External function subprograms required:
%   cwgn.m, chipr2.m
%
clear all
close all
randn('state',0) % initialize Gaussian random number generator
Pfa=0.01;  % set Pfa
gamma=2*log(1/Pfa);  % calculate threshold
sig2=1; % set up signal and noise parameters
f0=0.1;
N=50;
n=[0:N-1]';
A=0.46; % make a guess here and keep changing until Pd>0.95
e=exp(j*2*pi*f0*n);
s=A*e;
count=0; % initialize threshold crossing counter
ntrials=10000;
for i=1:ntrials
    w=cwgn(N,sig2); % generate CWGN
    x=s+w;
    T=abs(e'*x)^2/(N*(sig2/2)); % compute detector statistic
    if T>gamma
        count=count+1;
    end
end
Pdest=count/ntrials % estimate Pd
%  to check this result
lambda=2*N*A^2/sig2;
 Pd_true=chipr2(2,lambda,gamma,0.01)   % see [Kay 1998, pg. 485]
    
    






    
    


