% FSSP3exer12_12.m
%
%  This program implements the averaged periodogram spectral estimator
%  for complex data.  It is applied to the estimation of the PSD of CWGN.
%  The subprogram PSD_est_avper.m must be modified to handle complex data.
%  However, the modified program PSD_est_avper_complex.m is identical to
%  the original one since MATLAB automatically handles complex data without
%  any code modifications.
%
%  External function subprograms required:
%   cwgn.m, PSD_est_avper_complex.m
%
clear all
close all
randn('state',0) % initialize Gaussian random number generator
N=1000;  % set data record length
sig2=1;  % set CWGN variance
x=cwgn(N,sig2); % generate CWGN data
L=10;  % set block length equal to 10 so that 100 periodograms are averaged.
Nfft=2048;  % FFT length for Fourier transform
plotit=1;
plotdB=1;  % plot result in dB
[freq,Pavper]=PSD_est_avper_complex(x,L,Nfft,plotit,plotdB); % 
axis([-0.5 0.5 -10 10])  % set axis scaling



    
    


