% FSSP3exer12_4.m
%
%  This program estimates the ACS for CWGN.
%
%  External function subprograms required:
%   cwgn.m
%
clear all
close all
randn('state',0) % initialize Gaussian random number generator
N=1000;
sig2u=1; % noise variance
x=cwgn(N,sig2u); % generate CWGN process data
for k=0:9
   y=conj(x(1:N-k)).*x(1+k:N);  % compute lagged product
   rx(k+1)=sum(y)/N;  % compute ACS estimate
end
stem([0:9]',rx)
xlabel('k')
ylabel('$\hat{r}_x[k]$','interpreter','Latex')
grid




    
    


