% FSSP3exer12_5.m
%
%  This program computes and plots the PSD for a complex AR(1) random
%  process.  It illustrates that the PSD need not be symmetric.
%
clear all
close all
f=[-0.5:0.01:0.5]';  % set up frequencies
r=0.8;  % set radius of pole
f0=0.2; % set frequency (angle) of pole
a1=-r*exp(j*2*pi*f0);  % compute AR filter parameter
sig2u=1;  % set AR excitation noise variance
for i=1:length(f)  % compute PSD
    Px(i,1)=sig2u/abs(1+a1*exp(-j*2*pi*f(i)))^2;
end
figure
plot(f,Px)
xlabel('f')
ylabel('PSD')
grid
r=0.8;
f0=-0.2;  % move center frequency of PSD to a negative frequency
a1=-r*exp(j*2*pi*f0);
sig2u=1;
for i=1:length(f)
    Px(i,1)=sig2u/abs(1+a1*exp(-j*2*pi*f(i)))^2;
end
figure
plot(f,Px)
xlabel('f')
ylabel('PSD')
grid





    
    


