% FSSP3exer12_6.m
%
%  This program compares the theoretical SNR vs. the estimated SNR for a
%  complex sinusoid in complex noise.  The complex noise is a complex AR(1)
%  random process.
%
%  External function subprograms required:
%   ARgendata_complex.m
%
clear all
close all
randn('state',0) % initialize Gaussian random number generator
A=2*exp(j*pi/8);  % set complex amplitude
a=-0.9*exp(j*2*pi*0.3); % set complex AR filter parameter
sig2u=1; % set excitation white noise variance
N=1000;
n=[0:N-1]';
s=A*exp(j*2*pi*0.1*n);  % generate signal samples
rw0=sig2u/(1-abs(a)^2);  % calculate theoretical noise power
SNRdB=10*log10(abs(A)^2/rw0) % calculate theoretical SNR in dB
w=ARgendata_complex(a,sig2u,N); % generate realization of complex AR process
x=s+w;
pows=sum(abs(s).^2)/N;  % estimate signal power
poww=sum(abs(w).^2)/N;  % estimate noise power
SNRdBest=10*log10(pows/poww) % estimate SNR in dB





    
    


