% FSSP3exer12_9.m
%
%  This program estimates the parameters of a complex sinusoid embedded
%  in complex WGN. See (12.12) and (12.13).
%
%  External function subprograms required:
%   cwgn.m
%
clear all
close all
randn('state',0) % initialize Gaussian random number generator
A=-1+j;  % set complex amplitude
N=100;
n=[0:N-1]';  % set up time samples
f0=-0.2;
s=A*exp(j*2*pi*f0*n);  % compute signal samples
sig2=2; % set CWGN variance
w=cwgn(N,sig2);  % generate CWGN samples
x=s+w;  % compute complex data
f=[-0.5:0.001:0.5]';
for i=1:length(f)
    e=exp(j*2*pi*f(i)*n);
    I(i,1)=(1/N)*abs(e'*x)^2;  % compute periodogram - see (12.12)
end
[maxI Index]=max(I);  % find index where periodogram is maximum
f0hat=f(Index)  % compute MLE of frequency
e=exp(j*2*pi*f0hat*n);
Ahat=(1/N)*e'*x; % estimate of complex amplitude
Ahat_mag=abs(Ahat) % convert to magnitude for positive real amplitude
Ahat_phase=atan2(imag(Ahat),real(Ahat)) % convert to phase







    
    


