% FSSP3exer13_1.m
%
%  This program computes and plots the complex AR(1) PSD for two different
%  sets of the filter parameter.
%
clear all
close all
sig2u=1; % set AR parameters
r=0.8;f0=0.1;
a1=-r*exp(j*2*pi*f0);
f=[-0.5:0.01:0.5]';  % frequencies to compute PSD
Ps=sig2u./(abs(1+a1*exp(-j*2*pi*f)).^2); % calculate PSD - see (13.2)
figure
plot(f,Ps)
xlabel('f')
ylabel('PSD')
title('r=0.8, f0=0.1')
grid
axis([-0.5 0.5 0 30])  % use same scaling for both plots to allow an 
                       % easier visual comparison
r=0.6;f0=0.2; % repeat for new parameters
a1=-r*exp(j*2*pi*f0);
Ps=sig2u./(abs(1+a1*exp(-j*2*pi*f)).^2);
figure
plot(f,Ps)
xlabel('f')
ylabel('PSD')
title('r=0.6, f0=0.2')
grid
axis([-0.5 0.5 0 30])


