% FSSP3exer14_1.m
%
%  This program estimates the noise variance of the Gaussian part of the
%  noise shown in Figure 14.1 (the segment from 3000 to 4000 samples) and
%  then plots the 3 sigma limits on Figure 14.1 to determine if the spikes
%  exceed these limits.
%
clear all
close all
load FSSP3exer14_1  % load in data shown in Figure 14.1
w=w-mean(w);  % subtract out mean of data
wshort=w(3001:4001,1);  % pick out data that appears to be devoid of spikes
n=[3000:4000]';
figure  % plot the segment of data
plot(n,wshort)
grid
xlabel('n')
ylabel('w[n]')
title('segment used to estimate variance')
N=length(wshort);
varw=wshort'*wshort/N;  % estimate the variance
sigw=sqrt(varw)         % convert to the standard deviation estimate

nn=[0:length(w)-1]';
wmin=-3*sigw;  % set up limits
wmax=3*sigw;
Nw=length(w);
figure
plot(nn,w,nn,wmin*ones(Nw,1),nn,wmax*ones(Nw,1))  % compare noise data to
% determine if spikes are outside limits for Gaussian amplitudes
grid
xlabel('n')
ylabel('w[n]')
title('original data with mean subtracted')





