% FSSP3exer14_4.m
%
%  This program plots the limiter for a nonGaussian PDF modeled as an
%  AR(1) PDF with a real parameter.  The real parameter produces a
%  symmetric PDF about x=0,
%
clear all
close all

x=[-0.5:0.01:0.5]';  % set up x values (assumed that PDF is in 
                     % interval [-0.5,0.5]
a1=-0.95;            % first AR filter parameter
Amag2=abs(1+a1*exp(-j*2*pi*x)).^2;
num=-4*pi*a1*sin(2*pi*x);
g=num./Amag2; % compute limiter values
figure
plot(x,g)  % plot limiter characteristic
grid
xlabel('x')
ylabel('g(x)')
title('a[1]=-0.95')
a1=-0.8;  % change AR filter parameter and repeat
Amag2=abs(1+a1*exp(-j*2*pi*x)).^2;
num=-4*pi*a1*sin(2*pi*x);
g=num./Amag2;
figure
plot(x,g)
grid
xlabel('x')
ylabel('g(x)')
title('a[1]=-0.8')