% FSSP3exer15_1.m
%
%  This program computes the periodogram of the data shown in Figure 15.2
%  to see if the periodogram clearly displays the fundamental and harmonic
%  frequency peaks.
%
clear all
close all
Fs=360;  % set sampling rate
load FSSP3exer15_1  % load in data shown in Figure 15.2.  This is the chest
% electrode data, which is fairly "clean".  The array loaded in is called
% cecg and is 1080x1.
x=cecg; 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%x=hecg;  % This array corresponds to the 1080 samples shown in Figure 15.3
% and is the much noisier data obtained from the hand-hold contacts.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Nfft=9216;  % Set FFT length, which is chosen so that it is divisible by
            % 9.  Then, the frequency range of the first 9216/9=1024 points
            % is the analog frequency range of 0 to 40 Hz.
freqhz=([0:Nfft-1]'/Nfft)*Fs;  % analog frequencies are from 0 to 360 Hz
per=(1/1080)*abs(fft(x,Nfft)).^2; % compute periodogram
Imax=Nfft/9;  % obtain the first 1024 periodogram points
f=freqhz(1:Imax);  % pick off 1024 frequency points
p=per(1:Imax);     % pick off 1024 periodogram values
figure
plot(f,10*log10(p))
grid
axis([0 40 -20 10])  
xlabel('F (Hz)')
ylabel('Periodogram (dB)')




