% FSSP3exer4_9.m
%
%  This program models a PSD that is a two-sided exponential using an
%  AR PSD model.
%
clear all
close all
L=1024;
k=0;
for l=-L:L
    k=k+1; % reindex array since zero/negative indices not allowed
    f(k,1)=l/(2*L); % compute frequency values
    Pw(k,1)=exp(-10*abs(f(k))); % compute samples of desired PSD
end
p=4; % try p=10 for near perfect fit
[PAR,ahat,sig2uhat]=ARpsd_model(f,Pw,p); % find AR(p) PSD fit
plot(f,Pw,'--',f,PAR,'-') % plot results with AR(p) fit given by solid curve
                          % and desired PSD by dashed curve
grid
xlabel('f')
ylabel('PSD')




