% FSSP3exer5_7.m
%
% This program estimates the model order for the data shown in Figure 5.6
% by using the EEF.  It assumes that the maximum model order is k=4, i.e.,
% a cubic.
%
clear all
load FSSP3exer5_7 % load data shown in Figure 5.6
N=20;
n=[0:N-1]'; % set up time samples
H=[ones(N,1) n n.^2 n.^3]; % compute maximum size observation matrix
Hk=[];
for k=1:4
    Hk=[Hk H(:,k)]; % set up observation matrix with 1,2,3, or 4 columns
y=x'*Hk*inv(Hk'*Hk)*Hk'*x; % compute EEF test statistic
xik=N*y/(x'*x-y);
nk=k;
if xik/nk<1
    EEF(k,1)=0;
else
EEF(k,1)=xik-nk*(log(xik/nk)+1); % complete calculation of EEF
end
end
EEF



   
  