% FSSP3exer6_1.m
%
% This program compares the removal of a sinusoid using the 
% estimation/extraction method and the filtering method.
%
clear all
close all
load FSSP3exer6_1  % this will load in the time index n array, the sampled
% data array (sampled version of Figure 6.2), and the y[n] array shown in
% Figure 6.3.  All arrays are 400 x 1
b(1)=-2*cos(2*pi*0.06); b(2)=1; % set FIR filter coefficients
for nn=1:length(x) % filter x[n], setting initial conditions equal to zero
if nn==1
    z(1)=x(1);
elseif nn==2
    z(2)=x(2)+b(1)*x(1);
else
    z(nn)=x(nn)+b(1)*x(nn-1)+b(2)*x(nn-2);
end
end
figure % plot the residual data given in Figure 6.3 versus the FIR 
% filtered data
subplot(2,1,1)
plot(n,y)
xlabel('n')
ylabel('y[n]')
grid
axis([0 399 -10 10])
subplot(2,1,2)
plot(n,z)
xlabel('n')
ylabel('z[n]')
grid
axis([0 399 -10 10])


