% FSSP3exer6_17.m
%
%  This program computes and plots the averaged periodogram for 500 samples of an 
%  AR process.  It compares the spectral estimates for various number of
%  averaging blocks.
%
clear all
close all
randn('state',0) % initialize random number generator
r=0.95;f0=0.25;
a(1,1)=-2*r*cos(2*pi*f0);a(2,1)=r^2;sig2u=1; % set up AR parameters
[powsd,freq]=ARpsd(a,sig2u,1024);  % compute true PSD values and corresponding
                                   % frequencies and then plot 
figure
plot(freq,powsd)
grid
xlabel('f')
ylabel('true PSD')
axis([-0.5 0.5 0 120])

N=500;
x=ARgendata(a,sig2u,N);  % generate realization of AR process

figure
[freq,Pavper]=PSD_est_avper(x,500,1024,1,0); % compute and plot averaged
                                             % periodogram estimator for 1
                                             % block (L=500)
axis([-0.5 0.5 0 120])                                            
title('1 block')

figure
[freq,Pavper]=PSD_est_avper(x,100,1024,1,0);  % 5 blocks (L=100)
axis([-0.5 0.5 0 120])
title('5 blocks')

figure
[freq,Pavper]=PSD_est_avper(x,20,1024,1,0);   % 25 blocks (L=20)
axis([-0.5 0.5 0 120])
title('25 blocks')

 
 
 
 
  

 

 

 
 
 
 
 
         
   
   
   
   
   
   
   
