% FSSP3exer7_10.m
%
% This program computes the estimators for a DC level A in WGN.  The
% optimal estimator is the sample mean while the new estimator is a
% truncated version of the sample mean that is only valid if it is known
% that the value of A in in the interval [-2,2].
%
clear all
close all
randn('state',0) % initialize random number generator
N=5;
A=[2:0.01:4]'; % set up range of values of A
varw=5; % variance of WGN
AA=2;
for k=1:length(A)
for i=1:1000  % use 1000 trials
    x=A(k)+sqrt(varw)*randn(N,1); % generate DC level in WGN
 Aest(i,1)=mean(x);  % sample mean estimate
 if Aest(i)>AA % compute new estimator
     Anew(i,1)=AA;
 elseif Aest(i)<-AA
     Anew(i,1)=-AA;
 else
     Anew(i,1)=Aest(i);
 end
end
mse_sm(k,1)=mean((Aest-A(k)).^2); % compute mean square error
mse_new(k,1)=mean((Anew-A(k)).^2);
end
plot(A,mse_sm,A,mse_new)
grid
xlabel('A')
ylabel('MSE')
legend('sample mean','new estimator')


     






