% FSSP3exer7_4.m
%
% This program estimates the ROC for a DC level in WGN.  Two sets of
% data parameters are used but they both have the same SNR and therefore
% will produce the same ROC according to (7.4).
%
clear all
close all
randn('state',0) % initialize random number generator
N=10;  % set up signal parameters
A=1/sqrt(10);
for i=1:1000
    x=randn(N,1); % generate noise only data
    T0(i,1)=mean(x); % compute sample mean
    x=A+randn(N,1); % generate signal plus noise data
    T1(i,1)=mean(x); % compute sample mean
end
[Pfaest,Pdest,gam]=roccurve(T0,T1,50); % compute ROC 
figure
plot(Pfaest,Pdest) % plot ROC
xlabel('Pfa')
ylabel('Pd')
grid
title('$N=10, A=1\sqrt{10}$','interpreter','latex')

N=100;  % redo for new data parameters
A=0.1;
for i=1:1000
    x=randn(N,1);
    T0(i,1)=mean(x);
    x=A+randn(N,1);
    T1(i,1)=mean(x);
end
[Pfaest,Pdest,gam]=roccurve(T0,T1,50);
figure
plot(Pfaest,Pdest)
xlabel('Pfa')
ylabel('Pd')
grid
title('$N=100, A=0.1$','interpreter','latex')

 






  
    