% FSSP3exer7_6.m
%
% This program estimates the probability of error for a binary PSK
% communication system versus SNR.  The Q function subprogram, which is
% included on the CD, is required.
%
clear all
close all
randn('state',0) % initialize Gaussian random number generator
rand('state',0)  % initialize uniform random number generator
SNR=10^(5/10); % set up signal and noise parameters
N=10;
n=[0:N-1]';
varw=1;
A=sqrt((2*SNR*varw)/N);  
f0=0.25;
nreal=100000; % number of trials or realizations
    count=0;
        for i=1:nreal
        bit=floor(rand(1,1)+0.5); % generate bits with equal probability
        s=A*(2*bit-1)*cos(2*pi*f0*n);  % generate signal to represent each bit
        x=s+sqrt(varw)*randn(N,1); % generate data
        T=(1/N)*x'*cos(2*pi*f0*n); % compute receiver statistic
        if (T>=0 && bit==1)|(T<0 && bit==0) % decide on bit transmitted and if
                                      % it is decoded correctly
            count=count+1;
        end
        end
        Pe=1-count/nreal  % estimated Pe
  Pe_t=Q(sqrt(SNR))       % theoretical Pe - see (7.6)

 
 
     
 






  
    