% FSSP3exer7_8.m
%
% This program computes the theoretical normalized asymptotic variance for the 
% estimator of r_x[2] for an AR(1) random process.  Then, it determines
% the actual variance via computer simulation to determine how large the
% data record must be for the asymptotic expression to be valid.
clear all
close all
randn('state',0)
a1=-0.7;sig2u=1; % set AR parameters
r0=sig2u/(1-a1^2); % compute r_x[0]
Nvar=0;
for m=-50:50 % compute asymptotic variance as per (7.7)
    Nvar=Nvar+(r0*(-a1)^abs(m))^2+ (r0*(-a1)^(abs(m+2)))*(r0*(-a1)^(abs(m-2)));    
end
ntrials=100000;
for N=100:100:500 % for increasing data record lengths compute the variance
   for i=1:ntrials
    x=ARgendata(a1,sig2u,N); % generate outcome of AR process
    rhat(i,1)=(1/N)*sum(x(1:N-2).*x(3:N)); % estimate ACS for k=2
   end
temp=(rhat-mean(rhat))'*(rhat-mean(rhat)); % compute variance of estimator
Nvarest=(N*temp)/ntrials;
[N Nvarest Nvar] % list the data record length, true normalized variance 
                 % via simulation,  and the actual normalized asymptotic variance
end




    
       






