% FSSP3exer7_9.m
%
% This program determines the range of frequencies for which the
% periodogram is a good approximation to the MLE for a single sinusoid in
% WGN.
%
clear all
close all
f0=[0.0001:0.0001:0.4999]';  % set up range of frequencies for sinusoid
N=20;
n=[0:N-1]';  % set up time samples
f=[0.0001:0.0001:0.4999]';  % set up frequencies at which to evaluate periodogram
for i=1:length(f0)
    s=cos(2*pi*f0(i)*n); % compute signal for each signal frequency
    for k=1:length(f);
        e=exp(j*2*pi*f(k)*n);
    I(k,1)=(1/N)*abs(e'*s)^2; % compute periodogram
    end
    [mm K]=max(I);  % find frequency where periodogram has its maximum
    fest(i,1)=f(K);
end
abs_error=abs((f0-fest)); % calculate absolute estimation error
plot(f,abs_error)
xlabel('f0')
ylabel('absolute error')
grid
hold on
plot(f,0.01*ones(length(f),1))
hold off
    



    
       






