%  FSSP3exer9_11.m
%
%  This program estimates a periodic signal embedded in WGN.  It does so
%  by first estimating the period and then averaging over periods to 
%  estimate the basic period of the signal.
%
close all
clear all
randn('state',0) % initialize random number generator
N=130; 
n=[0:N-1]'; % set up time samples
s=[];
sig2=1;  % set WGN variance
for k=1:13  % compute periodic square wave with M=10
  s=[s;ones(5,1);-ones(5,1)];
end
x=s+sqrt(sig2)*randn(N,1);  % add WGN to signal
Mmin=5;Mmax=50;  % set up minimum and maximum periods for search
[shatr Mhat]= FSSP3alg9_11_sub(x,Mmin,Mmax,sig2); % call subprogram to
                            % estimate the period and the periodic signal
plot(n,s,n,shatr)
grid
xlabel('n')
ylabel('true and estimated signal')
legend('true signal','estimated signal')
Mhat  % estimated period printed
   
  