%  FSSP3exer9_13.m
%
% This program obtains the FIR filter coefficients for the adaptive noise
% canceler used to obtain the estimated signal of Figure 9.14b from the
% interference and noise corrupted signal shown in Figure 9.14a.
%
close all
clear all
load FSSP3exer9_13  % load in data shown in Figure 9.14a
N=100;
n=[0:N-1]'; % set up time samples
xR=cos(2*pi*0.1*n+pi/4)+cos(2*pi*0.2*n+pi/8);  % compute reference interference
p=4; % choose 4 FIR coefficients since the interference has two sinusoidal
% components and therefore requires the frequency  response to be zero at 
% 4 frequencies (two positive and two negative frequencies)
[shat hhat]=FSSP3alg9_13_sub(x,xR,p);  % find filter coefficients and 
                                       % subtract out interference
f=[0:0.001:0.5]';  % set up frequencies for filter frequency response
Hf=zeros(length(f),1);
for k=0:3   % compute complex frequency response H(f)
    e=exp(-j*2*pi*f*k);
    Hf=Hf+hhat(k+1)*e;
end
figure 
subplot(2,1,1)
plot(f,abs(Hf))  % plot magnitude response
xlabel('f')
ylabel('|H(f)|')
grid
subplot(2,1,2)
plot(f,angle(Hf))  % plot phase response
xlabel('f')
ylabel('phase of H(f) (rad)')
grid

hest=hhat
[mmin II]=min(abs(f-0.1));  % find index for f=0.1
[mmin JJ]=min(abs(f-0.2));  % find index for f=0.2
Hmag1=abs(Hf(II))  % print out magnitudes of frequency response at interference
             % frequencies
Hmag2=abs(Hf(JJ))
Hphase1=angle(Hf(II))/pi  % print out phases of frequency response at interference
% frequencies in multiples of pi
Hphase2=angle(Hf(JJ))/pi







    






        

   
