% FSSP3exer9_5.m
%
% This program illustrates that the width of the function (see (9.9)) 
% to be maximized to obtain the MLE of arrival angle in a line array 
% depends on the arrival angle.  This is due to the nonlinear 
% transformation from beta to the spatial frequency via a cosine 
% function - see (9.12).
%
clear all
close all
randn('state',0) % initialize Gaussian random number generator
c=1500; % speed of propagation of sound in water (m/sec)
F0=10000; % frequency in Hz
lambda=c/F0; % wavelength in m
d=lambda/2; % sensor spacing
beta_true=pi/8;  % change this to pi/16 to observe shift in the peak
A=1; % set up signal parameters
phi=pi/8;
M=20;
n=[0:M-1]'; % set up spatial samples
fs=F0*(d/c)*cos(beta_true); % spatial frequency
s=A*cos(2*pi*fs*n+phi); % compute signal samples
x=s; % set w[n]=0 since noise will not affect results greatly
[betahat beta Is]=FSSP3alg9_5_sub(x,F0,c,d); % run subprogram - see (9.9)
plot(beta,Is) % plot spatial periodogram
xlabel('beta')
ylabel('spatial periodogram')
grid




 
 

 

 
 
 
 
 
         
   
   
   
   
   
   
   
