% FSSP3exer9_7.m
%
% This program compares the approximate MLE estimator for the power of a
% stationary random process to that of a simple average sum of squares.
%
clear all
close all
randn('state',0) % initialize random number generator
r=0.7;f0=0.25;  % reduce the pole radius from the example
a(1,1)=-2*r*cos(2*pi*f0); % compute AR filter parameters
a(2,1)=r^2;
sig2u=0.76; % compute AR excitation noise variance
L=4096;
[powsd,freq]=ARpsd(a,sig2u,L);  % find values of PSD
Q=powsd;  % set Q(f) equal to PSD since P0=1
N=50;
n=[0:N-1]';
s=ARgendata(a,sig2u,N);  % generate AR data
P0hat_MLE=FSSP3alg9_7_sub(s,freq,Q) % run subprogram for MLE - see (9.14)
P0hat_squares=s'*s/N % use usual average sum of squares estimator - see (9.13)










 
 
 
 
 
         
   
   
   
   
   
   
   
