% FSSP3exer9_8.m
%
% This program estimates the center frequency of a bandpass random process.
% It demonstrates that the estimate is good even for a moderate amount of 
% noise.
%
clear all
close all
randn('state',0) % initialize Gaussian random number generator
r=0.98;f0=0.15;  % set up AR filter parameters for data to be generated
a(1,1)=-2*r*cos(2*pi*f0); % AR filter parameters for bandpass AR signal
a(2,1)=r^2;
sig2u=1; % set up AR excitation noise variance
N=50;
n=[0:N-1]'; % set up time samples
sig2=100; % set WGN variance
w=sqrt(sig2)*randn(N,1); % generate WGN samples
s=ARgendata(a,sig2u,N);  % generate AR signal
x=s+w;  % generate data
B=0.1; % set up parameters to input to estimation subprogram
alp(1,1)=-2*r;
alp(2,1)=r^2;
sig2u=1;
f0hat=FSSP3alg9_8_sub(x,alp,sig2u,B,sig2) % run subprogram to obtain estimate
                                          % of the center frequency of AR PSD



 
 
 
 
 
         
   
   
   
   
   
   
   
